import serial
import time
from pywinauto import Application, mouse, keyboard, Desktop

app = 0

def Key(string):
    keyboard.send_keys(string, pause=0.1)

def FCClick(pos):
    # Move mouse across first?
    mouse.click(coords = pos)
    time.sleep(1)
    
def FCStart():
    global app
    print("Flowcode starting")
    app = Application(backend="uia").start('C:\Program Files (x86)\Flowcode v9\launcher\FlowcodeLauncher.exe', timeout=60)
    time.sleep(20)
    FCClick((200, 390))
    time.sleep(5)
    FCClick((1120, 890))    
    time.sleep(5)
    FCClick((1120, 890))
    Key('{DOWN}{ENTER}')  
    time.sleep(5)
    FCClick((800,190))
    time.sleep(18)
    FCClick((900,380))
    
def FCCalc(body):
    Key('%c~')
    Key(body[0])
    Key('{TAB}')
    for str in body[1:]:
        Key(str)
        Key('~')
    Key('{TAB 2}~')
    
def FCVar(body):
    # Create a FC variable (local or global)
    FCClick((140, 385))
    Key('~')
    time.sleep(1)
    typ_y = 507 + 30 * int(body[0])
    for str in body[1:]:
        Key(str)
        Key('{TAB}')
    FCClick((860, typ_y))
    Key('{TAB 2}~')
    
def FCLoop(body):
    Key('%L~')
    Key(body[0])
    Key('{TAB 6}~')
    
def FCOutput(body):
    Key('%O~')
    Key(body[0])
    Key('{TAB}')
    Key('{DOWN 10}')
    Key('{TAB}')
    Key('{DEL}')
    Key(body[1])
    Key('~')
    Key('~')
    
def FCDelay(body):
    Key('%E~')
    Key(body[0])
    Key('{TAB}{DEL}')
    Key(body[1])
    FCClick((1125, 565))
    Key('{TAB 2}~')
    
def FCSaveAs(name):
    Key('^s')
    Key(name)
    time.sleep(2)
    Key('~{LEFT}~')
    
def FCBuild():
    FCClick((681, 46))
    FCClick((295, 100))
    time.sleep(10)

def FCComment(body):
    Key('%Y~')
    for s in body:
        Key(s)
        Key('~')
    Key('{TAB 2}~')
        
    
def DoCommand(cmd):
    print('Command', cmd)
    body = cmd[1:-2].decode().replace(' ', '{SPACE}').split(',')
    c = cmd[0]
    if c == ord('S') : 
        FCStart()
    if c == ord('C') :
        FCCalc(body)
    if c == ord('V'):
        FCClick((145, 260))
        FCVar(body)
    if c == ord('L'):
        FCLoop(body)
    if c == ord('O'):
        FCOutput(body)
    if c == ord('D'):
        FCDelay(body)
    if c == ord('A'):
        FCSaveAs(body[0])
    if c == ord('B'):
        FCBuild()
        return True
    if c == ord('Y'):
        FCComment(body)
    return False
        
success = False


def OpenPort():
    ser = serial.Serial(baudrate=9600)
    try:
        ser.port = "COM9"
        ser.open()
    except serial.SerialException:
        print ("Nano not found")
        ser.close()
    return ser

ser = OpenPort()
while not ser.is_open:
    time.sleep(1)
    ser = OpenPort()
    
print ("Nano on set")   
ok = False        
while ok == False:
    lin = ser.readline()
    print ('Received line', lin)
    ok = DoCommand(lin)
    time.sleep(5)
    ser.write(b'X')
ser.close()
time.sleep(5)
FCClick((414, 295))
    
#time.sleep(10);
#DoCommand(b'YThis is a,multiline, comment\r\n')
#DoCommand(b'V0,on,false,true if LED is on\r\n')
#DoCommand(b'LDo this forever\r\n')
#DoCommand(b'CToggle the LED,.on = !.on\r\n')
#DoCommand(b'OSet the LED on or off,.on\r\n')
#DoCommand(b'DPause for a second,1\r\n')
#DoCommand(b'Ablink\r\n')
#DoCommand(b'B\r\n')




